/**
 * DateTimePicker Component
 * @author yanrong.tian
 * @date 2022/4/12 下午2:41:24
 */
import React, { Component } from 'react';
import {Checkbox, Form} from 'antd';
import Base from '@icode-run/component-layout/utils/Base';
const CheckboxGroup = Checkbox.Group;
import {getOutputValue} from '@icode-run/utils/es/dataType';
// import styles from './index.module.less';

export default class MyCheckbox extends Base {
  componentDidMount() {

  }

  onChange = (checkedList) => {
    const {outputParam = {}} = this.props;
    if(outputParam.onChange && typeof outputParam.onChange === 'function') {
      const outputType = outputParam.outputType || '[string]';
      let newValue = checkedList;
      if(outputType === 'string') {
        newValue = checkedList && checkedList[checkedList.length - 1];
      }
      outputParam.onChange(newValue);
    }
  }

  renderContent = () => {
    const {
      outputParam = {}, 
      data,
      dimensionConfig,
      style,
      className,
      label,
      events = {},
    } = this.props;
    const enumOptions = this.getDimensionsData({
      data,
      dimensionConfig
    });

    const value = getOutputValue({
      outputType: '[string]', 
      value: outputParam.value
    });
    
    return <span className={!label ? className : ''} style={!label ? style : {}}>
      {enumOptions.length === 1 ? 
        <Checkbox 
          checked={value && value[0] ? true : false} 
          onChange={(e) => {
            const checked = e.target.checked;
            const value = checked ? [enumOptions[0].value] : [];
            this.onChange(value);
          }}
        >
          {enumOptions[0].label}
        </Checkbox> : 
        <CheckboxGroup 
          value={value}
          key={JSON.stringify(enumOptions)}
          options={enumOptions} 
          onChange={(checkedList) => {
            this.onChange(checkedList);
          }}
        />
      }
    </span>;
  }

  render() {
    const {
      label,
      className = '',
      style = {},
      outputParam = {},
    } = this.props;

    const content = this.renderContent();

    return  label ? <Form.Item
      className={className}
      style={style}
      {...(outputParam.name ? {
        name: outputParam.name,
      } : {})}
      label={label}
      // hasFeedback = {hasFeedback}
      // help={help}
      // validateStatus={validateStatus || ''}
      initialValue={getOutputValue({
        outputType: '[string]', 
        value: outputParam.value
      })}
      // onChange={(value) => {
      //  // this.onChange
      // }}
      rules={outputParam.rules}
      >
      {content}
    </Form.Item> : content;
  }
};
